;**************************************************************************
;
; Filename : WATCHDOG.ASM
; -----------------------
;
; (c) 1990 by Thomas Lehmann
;
;
; Jackophone V5.00
;
;
; Software Watchdog
;
;
;**************************************************************************

MODUL_START	set	*	; Gre des Moduls berechnen

; =========================================================================
;
; Funktion	: Software Watchdog
;	: wird Zyklisch aufgerufen
;	: RESET wenn IRQ oder Main Prg. stehenbleibt
;
; Eingang	: --------
;
; Ausgang	: --------
;
; Register	: --------
;
; (c) by Thomas Lehmann Februar 1991
;
; =========================================================================

	; =======================
	; Einsprung von Main Prg.
	; =======================
watchdog_m;	pha
	inc main_watch	; Main Prg. luft, frs IRQ Prg.
	lda irq_watch	; luft IRQ ?
	bne watch_ok	; ja

	dec main_wait	; Zeit zum nachtriggern lassen
	bne watch_end	; Zeit noch nicht abgelaufen

;	jmp init_stk	; RESET, IRQ steht

watch_ok	stz main_wait
	stz irq_watch	; wird vom Main Prg. nachgetriggert
watch_end;	pla
	rts



	; ======================
	; Einsprung von IRQ Prg.
	; ======================
watchdog_i	inc irq_watch	; IRQ luft, frs Main Prg.
	lda main_watch	; luft Main Prg. ?
	bne irq_w_ok	; ja

	dec irq_wait	; Zeit zum nachtriggern lassen
	bne watch_end	; Zeit noch nicht abgelaufen

;	jmp init_stk	; RESET, Main Prg. steht

irq_w_ok	stz irq_wait
	stz main_watch	; wird vom Main Prg. nachgetriggert
	rts


; --------------------------------------------------------------------------

HLP	set	*
_MAIN_WATCH	equ	HLP-MODUL_START		; Gre des Moduls

